macro(add_bench _name)
  set(_exe_name "mpp_${_name}")
  add_executable(${_exe_name} ${CMAKE_CURRENT_SOURCE_DIR}/${_name}.cpp)
  target_compile_options(${_exe_name} PRIVATE "$<$<CONFIG:Debug>:-Wall>")
  target_link_libraries(${_exe_name} PRIVATE maphyspp_minimal blaspp lapackpp MPI::MPI_CXX)
  target_compile_definitions(${_exe_name} PUBLIC MAPHYSPP_USE_LAPACKPP)

  install(TARGETS ${_exe_name} RUNTIME DESTINATION bin)

  if( MAPHYSPP_USE_QRMUMPS )
    target_link_libraries(${_exe_name} PUBLIC dqrm qrm_common)
    target_compile_definitions(${_exe_name} PUBLIC MPH_SDS_USE_QRMUMPS)
  endif()
  if( MAPHYSPP_USE_MUMPS )
    target_link_libraries(${_exe_name} PUBLIC MORSE::MUMPS)
    target_compile_definitions(${_exe_name} PUBLIC MPH_SDS_USE_MUMPS)    
  endif()
  if( MAPHYSPP_USE_PASTIX )
    target_link_libraries(${_exe_name} PUBLIC PASTIX::pastix)	
    target_compile_definitions(${_exe_name} PUBLIC MPH_SDS_USE_PASTIX)
  endif()
  if( MAPHYSPP_USE_EIGEN )
    target_include_directories(${_exe_name} SYSTEM PRIVATE ${EIGEN3_INCLUDE_DIRS})
    target_compile_definitions(${_exe_name} PRIVATE MPH_USE_EIGEN)
  endif()
endmacro()

add_bench(direct_solvers)
add_bench(part_impl_schur)

if( MAPHYSPP_USE_QRMUMPS )
  add_bench(qrm_gpu)
endif()
